/**
 * Copyright (C) 2015 - 2018 Kosmos contact@kosmos.fr
 *
 * Projet: blog
 * Version: 1.08.00-BETA-00
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package fr.kosmos.selenium.blog;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang3.StringUtils;
import org.testng.annotations.DataProvider;
import org.testng.annotations.Test;

import fr.kosmos.selenium.annotation.Exigence;
import fr.kosmos.selenium.bean.BilletDeBlogBean;
import fr.kosmos.selenium.bean.LibelleBean;
import fr.kosmos.selenium.core.KSupTestCase;
import fr.kosmos.selenium.screen.fiche.EcranCreateContentBilletDeBlog;
import fr.kosmos.selenium.screen.fiche.EcranSearchBilletDeBlog;
import fr.kosmos.selenium.service.ServiceListeDynamique;
import fr.kosmos.selenium.service.fiche.ServiceBilletDeBlog;
import fr.kosmos.selenium.utils.DateUtils;
import fr.kosmos.selenium.utils.RoleTest;

public class ITBilletDeBlogListeDynamiqueTestCase extends KSupTestCase {

    private ServiceBilletDeBlog serviceBilletDeBlog;
    private ServiceListeDynamique<BilletDeBlogBean, EcranCreateContentBilletDeBlog, EcranSearchBilletDeBlog> serviceListeDynamique;

    /**
     * {@inheritDoc}
     */
    @Override
    public void initScreen() {
        serviceBilletDeBlog = new ServiceBilletDeBlog(this);
        serviceListeDynamique = new ServiceListeDynamique<>(this, serviceBilletDeBlog);
    }

    private static List<String> listeToCheck1() {
        final List<String> list = new ArrayList<String>();
        //TODO
        return list;
    }

    private static List<String> listeToCheck2() {
        final List<String> list = new ArrayList<String>();
        //TODO
        return list;
    }

    private static BilletDeBlogBean listeDynamiqueBean1() {
        final BilletDeBlogBean bean = new BilletDeBlogBean();
        final List<String> tags = new ArrayList<>();
        tags.add("TAG1");
        bean.setTags(tags);
        bean.setDateDeMiseEnLigne(new LibelleBean(DateUtils.getDateFirstOfTheCurrentMonth(), DateUtils.getMonthAndYear(), StringUtils.EMPTY));
        bean.setDateDebut(DateUtils.dateToday());
        bean.setDateFin(DateUtils.dateToday());
        return bean;
    }

    private static BilletDeBlogBean listeDynamiqueBean2() {
        final BilletDeBlogBean bean = new BilletDeBlogBean();
        final List<String> tags = new ArrayList<>();
        tags.add("TAG1");
        bean.setTags(tags);
        return bean;
    }

    @DataProvider(name = "BeanListeDynamique")
    public static Object[][] listeDynamique() {
        return new Object[][] {
            { listeDynamiqueBean1(), "Titre page libre pour billet de blog 1", listeToCheck1() },
            { listeDynamiqueBean2(), "Titre page libre pour billet de blog 2", listeToCheck2() }
        };
    }

    @Test(dataProvider = "BeanListeDynamique")
    @Exigence(afinDe = "", enTantQue = RoleTest.ADMIN, jeVeux = "", ticketExigence = "KRTO-XXX", ticketTest = "KRTO-XXXX")
    public void testCreationListeDynamiqueBilletDeBlog(final BilletDeBlogBean bean, final String titrePageLibre, final List<String> listToCheck) {
        serviceListeDynamique.createListeDynamique(bean, titrePageLibre, listToCheck);
    }
}
